<template>
    <div class="w-full">
        <div class="headline flex flex-row items-center mb-2 mt-2 bg-gray-200 p-2">
            <div class="flex-grow text-md uppercase"> Project <span class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">#{{project.id}}</span> </div>
            <div class="actions">
                <button class="text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center bg-white rounded-md" v-on:click="back()">
                    <img class="fill-current inline-block w-6 h-6 mr-2" src="/components/pix/zond/arrow-thick-left.svg" />
                    <span>Back</span>
                </button>
            </div>
        </div>
        <wee-spatial-project-info v-if="loaded" :project="project" v-on:updated="reload()"></wee-spatial-project-info>
        <wee-spatial-project-types-editor v-if="loaded" :project="project" v-on:added="reload()" v-on:updated="reload()"></wee-spatial-project-types-editor>
        <wee-spatial-project-membership-editor :project="id"></wee-spatial-project-membership-editor>
        <wee-spatial-project-privilege-editor :project="id"></wee-spatial-project-privilege-editor>
    </div>
</template>
<script>
import axios from 'axios'
import WeeSpatialProjectInfo from './WeeSpatialProjectInfo'
import WeeSpatialProjectTypesEditor from './WeeSpatialProjectTypesEditor'
import WeeSpatialProjectMembershipEditor from './WeeSpatialProjectMembershipEditor'
import WeeSpatialProjectPrivilegeEditor from './WeeSpatialProjectPrivilegeEditor'

export default{
    name: "WeeSpatialProjectEditor",
    props: ["id"],
    components: {
        WeeSpatialProjectInfo,
        WeeSpatialProjectTypesEditor,
        WeeSpatialProjectMembershipEditor,
        WeeSpatialProjectPrivilegeEditor
    },
    data(){
        return {
            loaded: false,
            project: {}
        };
    },
    watch: {
        id(n, o){
            if(n){
                this.load();
            }else{
                this.loaded = false;
            }
        }
    },
    created(){
        if(this.id){
            this.load();
        }else{
            this.loaded = false;
        }
    },
    methods: {
        load(){
            let self = this;
            axios.get(this.projectUrl).then(function(response){
                self.project = response.data.project;
                self.loaded = true;
            }).catch(function(error){
                console.log(error);
            });
        },
        reload(){
            this.load();
        },
        back(){
            this.loaded = false;
            this.project = {};
            this.$emit("back");
        }
    },
    computed: {
        projectUrl(){
            return '/projects/'+this.id+'/synopsis';
        }
    }
}
</script>
<style>

</style>
